import axios from "axios";
import { LOADING_END, LOADING_START } from "../../../lib/redux/slices/appSlice";
import { createAsyncThunk } from "@reduxjs/toolkit";

export const provinceJahadEditHerdService = createAsyncThunk(
  "PROVINCE_JAHAD_EDIT_HERD_SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.put(
        "/LiveStock/live-stock/live-stock-view/0/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceJahadSubmitHerdService = createAsyncThunk(
  "PROVINCE_JAHAD_SUBMIT_HERD_SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.post(
        "/LiveStock/live-stock/live-stock-view/",
        d
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response.data.result };
    }
  }
);

export const provinceJahadDeleteHerdService = createAsyncThunk(
  "PROVINCE-JAHAD-DELETE-HERD-SERVICE",
  async (d, { dispatch }) => {
    dispatch(LOADING_START());
    try {
      const { data, status } = await axios.delete(
        `/LiveStock/live-stock/live-stock-view/0/?live_stock_key=${d.live_stock_key}`
      );
      dispatch(LOADING_END());
      return { data, status };
    } catch (e) {
      dispatch(LOADING_END());
      return { error: e.response?.data?.result || "خطا در بایگانی گله" };
    }
  }
);
